<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
<h2>Edit Schema</h2>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <h2>Columns</h2>
    {{ formset.management_form }}
    {% for form in formset %}
      <div class="column-form">
        {{ form.as_p }}
        <button type="button" class="delete-column" data-column-id="{{ form.instance.id }}">Delete Column</button>
      </div>
    {% endfor %}
    <button type="submit" class="save">Save</button>
    <button type="button" class="add-column">Add Column</button>
  </form>

  <script>
    $(document).ready(function() {
      $('.add-column').click(function() {
        var formCount = parseInt($('#id_form-TOTAL_FORMS').val());
        var newForm = $('.column-form:first').clone();
        newForm.find(':input').each(function() {
          var name = $(this).attr('name').replace('-' + (formCount - 1) + '-', '-' + formCount + '-');
          var id = 'id_' + name;
          $(this).attr({'name': name, 'id': id}).val('').removeAttr('checked');
        });
        newForm.insertBefore($('.add-column'));
        $('#id_form-TOTAL_FORMS').val(formCount + 1);
      });

      $('.delete-column').click(function() {
        if (confirm('Are you sure you want to delete this column?')) {
          var columnId = $(this).data('column-id');
          $('#delete_column').val(columnId);
          $('form').submit();
        }
      });
    });
  </script>

</body>
</html>